
// Alex Sherman (asherman@cs.columbia.edu) 
// 2009 
// The ALogger class takes care of logging the output to logs/bt.log

package alex;

import java.io.File;
import java.io.FileWriter;
import java.io.PrintWriter;


import java.io.*;
import java.util.*;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

//This class creates and maintains logs/bt.log file 

public class ALogger {

    public static int LOG_ERROR = -4;    
    public static int LOG_WARNING = -2;
    public static int LOG_INFO = 0;
    public static int LOG_DEBUG = 2;
    public static int LOG_DEBUG2 = 4;

    public static int DEBUG; 
    static int log_level = 0; 
    static boolean initialized = false; 
    static boolean initialized_log_level = false; 
    
    static String logname = "logs/bt.log";
    static PrintWriter pw = null; 
    
    public static void _init() {
	Runtime r = Runtime.getRuntime();
	try { 
	    r.exec("mkdir logs"); 
	    r.exec("touch " + logname);
	}
	catch (IOException e) {
	    e.printStackTrace();
	} 

	DEBUG = 4;
	initialized = true;
    } 
    
    public static void _get_log_level() {
	if (AManager.configured()) {
	    log_level = AManager.getConfObject().getLogLevel();
	    initialized_log_level = true;
	}
    }
 
    public static void log_wait(int level, String str, boolean bWaitToClose) {
	_log(level, str, bWaitToClose);
	
    } 
 
    public static void log(int level, String str) {
	if (level <= log_level) { 
	    _log(level, str, true);
	}
    } 


    public static void _log(int level, String str, boolean bFlush) {
	if (!initialized) {
	    _init();
	} 

	if (!initialized_log_level) {
	    _get_log_level();
	}

	Date now = new Date();
	//capital "H" is what causes the 0-23 hour system to be used 
	//as oppoed to hour in am or pm 
	SimpleDateFormat formatter = new SimpleDateFormat("HH:mm:ss");
	String s = formatter.format(now);
	String snew = "[" + s + "]  " + str; 

	try { 
	    if (pw==null) { 
		pw = new PrintWriter(new FileWriter(logname, true));
	    }
	    pw.println(snew);
	    if (bFlush) { 
		pw.flush();
	        //pw.close();
		//pw = null;
	    } 
	    System.out.println(snew);
	} catch(IOException e) {
	    e.printStackTrace();
	} 
		
    } 

} 

